//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "direct.h"
#include "stdio.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "AP_PDF2IMAGE_OCX"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
    //To create the com object.
    m_pAxPdf2Image = new TAxPdf2Image(this);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
    //To free the com object.
    if( m_pAxPdf2Image != NULL ){
        delete m_pAxPdf2Image;
    }
}
//---------------------------------------------------------------------------
//Demo1 - To convert all pages of the pdf document.
void __fastcall TMainForm::btnDemo1Click(TObject *Sender)
{
    DWORD iStartTick,iEndTick;

    AnsiString sFileName = "sample.pdf";
    iStartTick = GetTickCount();

    //Open pdf document and creating a converter.
    long nHandle = m_pAxPdf2Image->apOpen((WideString)sFileName, NULL, NULL);
    switch( nHandle ){
     case ERR_OVER_MAXTHREADS:{ ShowMessage("Over the limit amount of threads,please waiting!"); return; };
     case ERR_FILE_UNEXIST:{ ShowMessage("Source pdf file unexist!"); return; };
     case ERR_FILE_DAMAGED:{ ShowMessage("Source pdf file damaged!"); return; };
     case ERR_FILE_RESTRICTED:{ ShowMessage("Source pdf file restricted!"); return; };
    }

    //Setting proerties.
    m_pAxPdf2Image->sOutDirectory = "./demo1";
    m_pAxPdf2Image->iImageType = AP_IMAGE_PNG;
    m_pAxPdf2Image->iXDPI = 130;
    m_pAxPdf2Image->iYDPI = 130;

    //To convert all pages of the pdf document.
    long iPageCount = m_pAxPdf2Image->apGetPageCount(nHandle);
    for(int iPageNo = 1; iPageNo <= iPageCount; iPageNo++){
       m_pAxPdf2Image->apConvertPage(nHandle,iPageNo);

       //Setting conversion's progress.
       m_ProgressBar->Position = (long)((iPageNo)*1.0/iPageCount*100);
    }

    //Close pdf document and destory the converter.
    m_pAxPdf2Image->apClose(nHandle);

    iEndTick = GetTickCount();
    ShowMessage("Conversion successful,it passed "+IntToStr(iEndTick-iStartTick)+"ms!");
}
//---------------------------------------------------------------------------
//demo2 - To convert appointed pdf pages of the pdf document to memory stream.
void __fastcall TMainForm::btnDemo2Click(TObject *Sender)
{
    DWORD iStartTick,iEndTick;
    DWORD m_Pages[6] = {1, 3, 6, 8, 9, 11};

    AnsiString sFileName = "sample.pdf";
    iStartTick = GetTickCount();

    //Open pdf document and creating a converter.
    long nHandle = m_pAxPdf2Image->apOpen((WideString)sFileName, NULL, NULL);
    switch( nHandle ){
     case ERR_OVER_MAXTHREADS:{ ShowMessage("Over the limit amount of threads,please waiting!"); return; };
     case ERR_FILE_UNEXIST:{ ShowMessage("Source pdf file unexist!"); return; };
     case ERR_FILE_DAMAGED:{ ShowMessage("Source pdf file damaged!"); return; };
     case ERR_FILE_RESTRICTED:{ ShowMessage("Source pdf file restricted!"); return; };
    }

    //Setting proerties.
    m_pAxPdf2Image->iImageType = AP_IMAGE_JPEG;
    m_pAxPdf2Image->iQuality = 60;
    m_pAxPdf2Image->iXDPI = 110;
    m_pAxPdf2Image->iYDPI = 110;
    m_pAxPdf2Image->iXDimensions = 995;
    m_pAxPdf2Image->iYDimensions = 1287;

    //To convert the appointed pages of the pdf document.
    long iPageCount = 6;
    for(int iPos = 0; iPos <= iPageCount - 1; iPos++){
       //You can save image stream to database, to file, or to others, etc.
       //The "pImageStream" is a pointer which point to the memory stream of an image.
       m_pAxPdf2Image->apConvertPageToStream(nHandle,m_Pages[iPos]);
       BYTE *pImageStream = (BYTE *)m_pAxPdf2Image->iStreamHandle;

       //Here,the stream is saved to file.
       if( pImageStream != NULL && m_pAxPdf2Image->iStreamSize > 0 ){
            char sImgFile[256];
            _mkdir("./demo2");
            sprintf(sImgFile,"./demo2/myimg_%02d.jpg",m_Pages[iPos]);

            FILE *pFile = fopen(sImgFile,"wb");
            if( pFile != NULL ){
                fwrite(pImageStream,1,m_pAxPdf2Image->iStreamSize,pFile);
                fclose(pFile);
            }
       }

       //Setting conversion's progress.
       m_ProgressBar->Position = (long)((iPos+1)*1.0/iPageCount*100);
    }

    //Close pdf document and destory the converter.
    m_pAxPdf2Image->apClose(nHandle);

    iEndTick = GetTickCount();
    ShowMessage("Conversion successful,it passed "+IntToStr(iEndTick-iStartTick)+"ms!");
}
//---------------------------------------------------------------------------
